using BlazorIronBarcodeWithCAM.Shared;
using Microsoft.AspNetCore.Mvc;
using System.Drawing;

namespace BlazorIronBarcodeWithCAM.Server.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class WeatherForecastController : ControllerBase
    {
        private static readonly string[] Summaries = new[]
        {
        "Freezing", "Bracing", "Chilly", "Cool", "Mild", "Warm", "Balmy", "Hot", "Sweltering", "Scorching"
    };

        private readonly ILogger<WeatherForecastController> _logger;

        public WeatherForecastController(ILogger<WeatherForecastController> logger)
        {
            _logger = logger;
        }

        [HttpGet]
        public IEnumerable<WeatherForecast> Get()
        {
            return Enumerable.Range(1, 5).Select(index => new WeatherForecast
            {
                Date = DateTime.Now.AddDays(index),
                TemperatureC = Random.Shared.Next(-20, 55),
                Summary = Summaries[Random.Shared.Next(Summaries.Length)]
            })
            .ToArray();
        }

        [HttpPost]
        [Route("ReadBarCode")]
        public string ReadBarCode(CamImage imageData)
        {
            try
            {
                var splitObject = imageData.imageDataBase64.Split(',');
                byte[] imagebyteData = Convert.FromBase64String((splitObject.Length > 1) ? splitObject[1] : splitObject[0]);
                IronBarCode.License.LicenseKey = "Key";

                using (var ms = new MemoryStream(imagebyteData))
                {
                    Image barcodeImage = Image.FromStream(ms);
                    var result = IronBarCode.BarcodeReader.QuicklyReadOneBarcode(barcodeImage);
                    if (result == null || result.Value == null)
                    {
                        return $"{DateTime.Now} : Barcode is Not Detetced";
                    }

                    return $"{DateTime.Now} : Barcode is ({result.Value})";
                }

            }
            catch (Exception ex)
            {
                return $"Exception is {ex.Message}";
            }
        }
    }
}